# React Progress Bar Plus

Progress bar component for ReactJS. A modification of https://github.com/minhtranite/react-progress-bar-plus

## Installation

### NPM
```bash
npm install --save react-line-progress
```

### Bower
```bash
bower install --save react-line-progress
```

## Usage

### JS

```js
var ProgressBar = require('react-line-progress');

<ProgressBar percent={10}/>
```

### CSS

**Webpack:**

```js
require('react-line-progress/lib/progress-bar.css');
```

**Without Webpack:**

```html
<link rel="stylesheet" type="text/css" href="path/to/react-line-progress/lib/progress-bar.css">
```

### UMD

```html
<link rel="stylesheet" type="text/css" href="path/to/react-line-progress/dist/progress-bar.css">
<script src="path/to/react-line-progress/dist/react-line-progress.js"></script>
```

```js
...
var ProgressBar = window.ReactProgressBarPlus;
...
```

## Props
| Name | Type | Default | Description |
|------|------|---------|-------------|
| percent | number | -1 | Progress percent |
| onTop | bool | false | Progress bar will ontop & height 100% |
| autoIncrement | bool | false | if `true` percent will auto increment `Math.random() + 1 - Math.random()`% in `intervalTime` ms. |
| intervalTime | number | 200 | Interval time for auto increment. |
| spinner | oneOf([false, 'left', 'right'])   | left | Spinner position. Pass `false` to hide spinner icon. |
| className | string |  | Custom class |