'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames2 = require('classnames');

var _classnames3 = _interopRequireDefault(_classnames2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar(props) {
    _classCallCheck(this, ProgressBar);

    var _this = _possibleConstructorReturn(this, (ProgressBar.__proto__ || Object.getPrototypeOf(ProgressBar)).call(this, props));

    _initialiseProps.call(_this);

    _this.state = {
      percent: props.percent
    };
    return _this;
  }

  _createClass(ProgressBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onTop = _props.onTop,
          spinner = _props.spinner,
          className = _props.className;
      var percent = this.state.percent;

      className = (0, _classnames3.default)('react-progress-bar', className, {
        'react-progress-bar-on-top': onTop,
        'react-progress-bar-hide': percent < 0 || percent >= 100
      });
      var style = { width: (percent < 0 ? 0 : percent) + '%' };
      var spinnerClassName = (0, _classnames3.default)('react-progress-bar-spinner', _defineProperty({}, 'react-progress-bar-spinner-' + spinner, spinner));
      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement('div', { className: 'react-progress-bar-percent', style: style }),
        spinner ? _react2.default.createElement(
          'div',
          { className: spinnerClassName },
          _react2.default.createElement('div', { className: 'react-progress-bar-spinner-icon' })
        ) : null
      );
    }
  }]);

  return ProgressBar;
}(_react2.default.Component);

ProgressBar.propTypes = {
  className: _propTypes2.default.string,
  percent: _propTypes2.default.number.isRequired,
  onTop: _propTypes2.default.bool,
  autoIncrement: _propTypes2.default.bool,
  intervalTime: _propTypes2.default.number,
  spinner: _propTypes2.default.oneOf([false, 'left', 'right'])
};
ProgressBar.defaultProps = {
  percent: -1,
  onTop: false,
  autoIncrement: false,
  intervalTime: 200,
  spinner: 'left'
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.componentDidMount = function () {
    _this2.handleProps(_this2.props);
  };

  this.componentWillReceiveProps = function (nextProps) {
    if (_this2.interval) {
      clearInterval(_this2.interval);
    }
    if (_this2.timeout) {
      clearTimeout(_this2.timeout);
    }
    _this2.handleProps(nextProps);
  };

  this.componentWillUnmount = function () {
    if (_this2.interval) {
      clearInterval(_this2.interval);
    }
    if (_this2.timeout) {
      clearTimeout(_this2.timeout);
    }
  };

  this.increment = function () {
    var percent = _this2.state.percent;

    percent = percent + (Math.random() + 1 - Math.random());
    percent = percent < 99 ? percent : 99;
    _this2.setState({
      percent: percent
    });
  };

  this.handleProps = function (props) {
    if (props.autoIncrement && props.percent >= 0 && props.percent < 99) {
      _this2.interval = setInterval(_this2.increment, props.intervalTime);
    }

    if (props.percent >= 100 && props.percent !== _this2.props.percent) {
      _this2.setState({
        percent: 99.9
      }, function () {
        _this2.timeout = setTimeout(function () {
          _this2.setState({
            percent: -1
          });
        }, 400);
      });
    } else {
      _this2.setState({
        percent: props.percent
      });
    }
  };
};

exports.default = ProgressBar;